#ifndef _ICOMIC_
#define _ICOMIC_

#define MANAGER_VERSION 1			// TODO: Define here the pluginManager version !!! (In pluginManager.h)
#define PLUGIN_NAME	 	"iComic"		// TODO: Define here the plugin Name

#include <gio/gio.h>
#include <string.h>

#include <iostream>
#include <algorithm>
#include <vector>

#include "../gloobus-preview-interface-document.h"

using namespace std;

class iComic : public iDocument
{

  	int							m_n_pages;
	vector<string>				m_pagenames;
	char 	*					m_extract_command;
	char 	*					m_list_command;
	int							m_width;
	int							m_height;

	
	public:
	virtual int						get_n_pages		( void );
	virtual int						get_page_width  ( void );
	virtual int						get_page_height ( void );
	virtual GdkPixbuf*				get_page_pixbuf ( int n_page );
	virtual	void				end_plugin 		( void );
	bool							check_valid		(char *filename);


									iComic (void);
	private:

  	void							load_comic 		( void );
  	void							calculate_size 	( void );
  	void							sort_pagenames 	( void );
			

};



// ============================ Class factories======================================== //
// This is "allways the same" code, just change the plugin name in the printf and the 
// return object
extern "C" iDocument* create() {		
	printf("Creating iComic...\n");
    return new iComic;
}

extern "C" void destroy(iDocument* p) {
	printf("Destroying iComic...\n");
    delete p;
}

extern "C" int getVersion(){			//To save crashes from older versions
	return MANAGER_VERSION;
}

// ============================== REGISTER ============================================ //
// Here is where we register the new plugin, what we do is to add a map with the plugin
// name and the mime file types it can load, then, the pluginManager will take care of wich
// plugin load, depending on its file type. Just add more than one file type adding this
// two lines as many times you want.
//
//	itself.filetype = "image/bmp";			// Add another extension supported
//	pluginVector.push_back(itself);			// Add filetype that plugin reads

extern "C" 
{
   class proxy {
		public:
	   	proxy()
		{
			//TODO: Add here the mime filetypes that plugin supports
			//plugin_filetype itself = {PLUGIN_NAME,EXTENSION,TYPE,PRIORITY}
			
			plugin_filetype itself = { PLUGIN_NAME, "application/x-cbz","document",1};		// Initial filetype

			factory_document[itself.name] = create;		    	// Register the plugin
			factoryDestroy_document[itself.name] = destroy;		// Function for destroy this plugin class
			pluginVector.push_back(itself);					// Add filetype that plugin reads
			
			itself.filetype = "application/x-cbr";			// Add another extension supported
			pluginVector.push_back(itself);			// Add filetype that plugin reads
		    
	   }
 };
 proxy p;	// When we open the dll with RTLD_NOW it creates p, and in consequence, it registers the plugin 
}

#endif

